<?php

namespace Teknisa\SM\Service;

use Zeedhi\Framework\Session\Session;

class IntegracoesTeknisaService {
    
    const CLIENT_ID     = "cd7e85178153by60953518945f9hakt19a50a4";
    const CLIENT_SECRET = "lib5449996c21f780fe30badd6521931a5sac9";
    
    const CLIENT_ID_HCM     = "1193";
    const CLIENT_SECRET_HCM = "d7b4acf88d57a2b95cb9a1b89d7d756a59cac475c6b8143";
    
    protected $session;
    protected $connectionParams;

    public function __construct(Session $session, $connectionParams = null) {
        $this->session          = $session;
        $this->connectionParams = $connectionParams;
    }
   
    /**
     * Executa uma requisição curl.
     * 
     * @param string  $token
     * @param string  $urlIntegracao (urlBase+rota)
     * @param mixed[] $dados
     * 
     * @return mixed[]
     */
    public function executarCurl($token, $urlIntegracao, $dados, $segundosTimeout = 165) {
        set_time_limit($segundosTimeout);

        $header = array();
        $header[] = "OAuth-Token: " . $token;
        $header[] = "OAuth-SecretId: " . self::CLIENT_SECRET;
        $header[] = "Content-Type: application/json";
        $header[] = "Content-Length: " . strlen(json_encode($dados));

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_URL, $urlIntegracao);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($dados));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $segundosTimeout);

        $resultado = curl_exec($ch);
        $resultado = json_decode($resultado, true);
        $error     = curl_error($ch);

        curl_close($ch);

        if (!empty($resultado["error"])) {
            throw new \Exception($resultado["error"]);
        }
        else if (!empty($error)) {
            throw new \Exception($error);
        }
        else {
            return isset($resultado["dataset"]) ? $resultado["dataset"] : null;
        }
    }
    
    /**
     * Retorna o token para a comunicação curl.
     * @params $urlBase url base do produto
     * @return string
     */
    private function getToken($urlBase) {
        
        $param = array(
            "CLIENT_ID"     => self::CLIENT_ID,
            "CLIENT_SECRET" => self::CLIENT_SECRET
        );
        $token = $this->executarCurl(null, $urlBase . "/lib_requestToken", $param);
     
        
        $token = $token["token"][0];
        $this->session->set("lib_token", $token);
        return $token;
    }
    
    /**
     * Envia os dados usados nas integrações teknisa
     * @params $urlBase url base do produto
     * @params $rota rota do metodo de integração
     * @params $dadosIntegracao dados utilizados
     */
    public function enviarDadosIntegracao($urlBase, $rota, $dadosIntegracao) {
        try {
            $dados = array(
                "requestType" => "DataSet",
                "dataset"     => array($dadosIntegracao)
            );
            $token   = $this->getToken($urlBase);
            $retorno = $this->executarCurl($token, $urlBase . $rota, $dados);
            
            return $retorno;
        } catch (\Exception $e) {
               throw $e; 
        }
    }
    
    /**
     * Envia os dados usados nas integrações teknisa
     * @params $urlBase url base do produto
     * @params $rota rota do metodo de integração
     * @params $dadosIntegracao dados utilizados
     */
    public function enviarDadosIntegracaoOM($urlBase, $rota, $dadosIntegracao) {
        try {
            $retorno = null;
            $dados = array(
                "requestType" => "DataSet",
                "dataset"     => array($dadosIntegracao)
            );
          
            $token   = $this->getToken($urlBase);
            $retorno = $this->executarCurl($token, $urlBase . $rota, $dados, 465);
            return $retorno;
        } catch (\Exception $e) {
            $erro = $e->getMessage();
            
            $id = preg_replace("/\D/", '', $erro);

            if ($id != null && strpos($erro, 'Não foi possível criar a organização, pois o produto') !== false && strpos($erro, 'não possui um elemento com a uniqueId a seguir') !== false){
                    
                // Se o ID não existe mais, deve ser retirado o ID da lista e enviar a lista novamente para o OM. Para isso, será retornado o ID inválido através da variável $id
                
                $dadosIntegracaoAux = $dadosIntegracao;
                foreach ($dadosIntegracaoAux["products"] as $indP => $prod) {
                    
                    foreach ($prod["elements"] as $indE => $elementos) {
                        
                        if ($elementos["id"] == $id) {
                            
                            unset($dadosIntegracao["products"][$indP]["elements"][$indE]);
                        }
                    }
                }
                
                return $this->enviarDadosIntegracaoOM($urlBase, $rota, $dadosIntegracao);
            } else {
               throw new \Exception("Falha na integração com o módulo OM:<br/>" . $e->getMessage());
            }
        }
    }
    
    /**
     * Executa uma requisição curl   NESTE CASO COM OS PARÂMETROS E TIPO DE REQUISIÇÃO NOS
     * MOLDES DO HCM POIS ESTE WEBSERVICE PROVEM DO DELPH.
     * 
     * @param string  $token
     * @param string  $urlIntegracao (urlBase+rota)
     * @param mixed[] $dados
     * 
     * @return mixed[]
     */
    private function executarCurlHCM($token, $urlIntegracao, $dados) {
        $uri = $urlIntegracao;
        $data = $dados;
        $header = array();
        $header[] = "OAuth-Token: " . $token;
        $header[] = "OAuth-SecretId: " . self::CLIENT_SECRET_HCM;
        $header[] = 'Content-Type: application/json';
        $header[] = 'Content-Length: ' . strlen(json_encode($data));
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_URL, $uri);
        curl_setopt($ch, CURLOPT_POST, count($data));
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        
        $result = curl_exec($ch);
        $result = json_decode($result, true);
        $error = curl_error($ch);
        curl_close($ch);
        
        if (!empty($result["error"])) {
            throw new \Exception($result["error"]);
        }
        else if (!empty($error)) {
            throw new \Exception($error);
        }
        else {
            return isset($result["dataset"]) ? $result["dataset"] : null;
        }
    }
    
     /**
     * Retorna o token para a comunicação curl.
     * @params $urlBase url base do produto
     * @return string
     */
    
     private function getTokenHCM($urlBase) {
        $param = array(
            "CLIENT_ID"     => self::CLIENT_ID_HCM,
            "CLIENT_SECRET" => self::CLIENT_SECRET_HCM
        );
        
        $token = $this->executarCurlHCM(null, $urlBase . "requestToken", $param);
        $token = $token["token"][0];
        $this->session->set("lib_token", $token);
        return $token;
        
    }
    
     /**
     * Envia os dados usados nas integrações teknisa
     * @params $urlBase url base do produto
     * @params $rota rota do metodo de integração
     * @params $dadosIntegracao dados utilizados
    **/
    
    public function enviarDadosIntegracaoHCM($urlBase, $rota, $dadosIntegracao) {
        try {
            $dados = array(
                "requestType" => "Row",
                "row"         => $dadosIntegracao
            );
            $token   = $this->getTokenHCM($urlBase);
            $retorno = $this->executarCurlHCM($token, $urlBase . $rota, $dados);
            return $retorno;
        }
        catch (\Exception $e) {
            throw $e;
        }
    }

    public function enviarDadosIntegracaoErpFilial($url, $dadosIntegracao, $email, $senha) {
        $dados = array(
            "requestType" => "DataSet",
            "dataset"     => array($dadosIntegracao)
        );
        $retorno = $this->executarCurlErpFilial($url, $dados, $email, $senha);
        
        return $retorno;
    }

    private function executarCurlErpFilial($urlIntegracao, $dados, $email, $senha) {
        $segundosTimeout = 165; //2 min e 45 seg
        set_time_limit($segundosTimeout);
        
        $header = array();
        $header[] = "Content-Type: application/json";
        $header[] = "Content-Length: " . strlen(json_encode($dados));
        $header[] = "emailoper: " . $email;
        $header[] = "senhaoper: " . $senha;
        
        $header[] = "dbuser: " . $this->connectionParams["user"];
        $header[] = "dbpass: " . $this->connectionParams["password"];
        $header[] = "dbhost: " . $this->connectionParams["host"];
        $header[] = "dbport: " . $this->connectionParams["port"];
        $header[] = "dbname: " . $this->connectionParams["dbname"];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_URL, $urlIntegracao);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($dados));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $segundosTimeout);
        
        $resultado = curl_exec($ch);
       
        $resultado = json_decode($resultado, true);
        $error     = curl_error($ch);
        curl_close($ch);

        if (!empty($resultado["error"])) {
            throw new \Exception($resultado["error"]);
        }
        else if (!empty($error)) {
            throw new \Exception($error);
        }
        else {
            return $resultado;
        }
    }

    public function enviarDadosIntegracaoErpFilialEnde($url, $dadosIntegracao, $email, $senha) {
        $dados = array(
            "requestType" => "DataSet",
            "dataset"     => array($dadosIntegracao)
        );
        $retorno = $this->executarCurlErpEndeFili($url, $dados, $email, $senha);
        
        return $retorno;
    }

    private function executarCurlErpEndeFili($urlIntegracao, $dados, $email, $senha) {
        $segundosTimeout = 165; //2 min e 45 seg
        set_time_limit($segundosTimeout);
        
        $header = array();
        $header[] = "Content-Type: application/json";
        $header[] = "Content-Length: " . strlen(json_encode($dados));
        $header[] = "emailoper: " . $email;
        $header[] = "senhaoper: " . $senha;
        
        $header[] = "dbuser: " . $this->connectionParams["user"];
        $header[] = "dbpass: " . $this->connectionParams["password"];
        $header[] = "dbhost: " . $this->connectionParams["host"];
        $header[] = "dbport: " . $this->connectionParams["port"];
        $header[] = "dbname: " . $this->connectionParams["dbname"];
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_URL, $urlIntegracao);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($dados));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $segundosTimeout);
        
        $resultado = curl_exec($ch);
        
        $resultado = json_decode($resultado, true);
        $error     = curl_error($ch);
        curl_close($ch);

        if (!empty($resultado["error"])) {
            throw new \Exception($resultado["error"]);
        }
        else if (!empty($error)) {
            throw new \Exception($error);
        }
        else {
            return $resultado;
        }
    }
}