/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUPAPR                                                      */
/* Tabela : PADRTXTPROP                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 19/06/2006 - Eduardo H. c. Ramos                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUPAPR
BEFORE INSERT OR UPDATE OR DELETE
ON PADRTXTPROP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPAPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPADTXT,0) <> NVL(:NEW.CDPADTXT,0)) THEN
         
         :NEW.DTULTATUPAPR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PADRTXTPROP', '', 'CDPADTXT='||:OLD.CDPADTXT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PADRTXTPROP MODIFY DTULTATUPAPR DEFAULT SYSDATE
/