<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class GpePerfacestiposoli extends \Doctrine\ORM\EntityRepository {
    
    public function retornaProximaFase($nrorg, $nrtiposolicitacao, $nrordem) {
        $gpePerfacestiposoli = Repositories::GPE_PERFACESTIPOSOLI;
        $gpeModeloaprovsoli = Repositories::GPE_MODELOAPROVSOLI;
        $gpeFaseaprovsoli = Repositories::GPE_FASEAPROVSOLI;

        $sql = <<<SQL
SELECT f
  FROM $gpePerfacestiposoli p
  JOIN $gpeModeloaprovsoli m WITH m.nrorg = p.nrorg
                              AND m.nrmodeloaprovsoli = p.nrmodeloaprovsoli
  JOIN $gpeFaseaprovsoli f WITH f.nrorg = m.nrorg
                            AND f.nrmodeloaprovsoli = m.nrmodeloaprovsoli
                            AND f.nrordem > :nrordem
 WHERE p.nrorg = :nrorg
   AND p.nrtiposolicitacao = :nrtiposolicitacao
 ORDER BY f.nrordem ASC
SQL;
        $params = array(
            'nrorg' => $nrorg,
            'nrtiposolicitacao' => $nrtiposolicitacao,
            'nrordem' => $nrordem
        );
        $result = current($this->getEntityManager()->createQuery($sql)->execute($params));
        return $result;
    }

    
}